### 当贝支付委托扣款对接流程

#### 准备工作
商务对接，CP提供签约回调接口给当贝支付开发，当贝支付进行开通权限后即可配置自动续费相关逻辑


#### 签约回调接口
用户扫码后进行签约，签约成功后，会将信息回调给接入方回调接口。
参数如下


```
{
  "datastr": "%7B%22contract_code%22%3A%22149294695220190422164948677%22%2C%22appid%22%3A%22a12e649ccbb037e3ab7030985741b0ed%22%2C%22contract_id%22%3A%22201904221650217515%22%2C%22salt%22%3A%22a426d45b%22%2C%22status%22%3A1%7D",
  "sign": "B9F2A8A8CD65B8C532C53CA8A3FBF6BF"
}
```

##### 回调参数说明
1. datastr字段是签约回调的信息，将其urldecode后会得到以下JSON字符串：

```
{
  "contract_code": "149294695220190422164948677",  //签约code
  "appid": "a12e649ccbb037e3ab7030985741b0ed", //接入方应用id
  "contract_id": "201904221650217515",,  //签约协议号， 
  "salt": "a426d45b", //签约盐值，用来对参数进行加密验签，注意保存并进行保密。
  "order":"11112222", //商户生成的订单号，用于绑定
  "status": 1 // 签约状态，1为签约成功，0为解约，用户签约和解约都会发送回调信息，接入方需要判断状态，来处理相关业务，如解约后不再发送扣款请求等
}

```
以上信息请妥善保管，并和相关用户对应，后期发送扣款请求时会用到。




#### 接入方请求委托扣款

用户第一次签约之后会自动扣第一次的款，扣款会回调到支付回调接口，即委托扣款和非委托扣款的回调是同一个。

之后接入方需要根据用户所购买的套餐在对应的时间发起委托扣款（一般为会员到期前2天左右），具体接口文档详见：当贝支付请求委托扣款.md


 
#### 发送公众号模板

当贝支付提供了一个发送公众号模板消息的接口，接入方需要在扣款前一天或者其他时间告知用户即将扣款，以及在扣款成功后告诉用户扣款已经成功。
具体接口文档见：当贝支付发送公众号模板消息.md

 